import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import processing.serial.*; 
import controlP5.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class UltraESC_Config_1_1 extends PApplet {

/*
UltraESC GUI v1_0_RELEASE by Felix Niessen & Dieter W\u00fcrtenberger

based on

MultiWiiConf by Alexandre Dubus
www.multiwii.com


This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version. see <http://www.gnu.org/licenses/>
*/

 // serial library
 // controlP5 library

Serial g_serial;
ControlP5 controlP5; // create the handler to allow for controlP5 items
Textlabel txtlblWhichcom; // text label displaying which comm port is being used
ListBox commListbox; // list of available comm ports
Textlabel version;

/*=====================================================================================
  position setting
=====================================================================================*/
cGraph g_graph;
int windowsX    = 800;
int windowsY    = 520;
int xGraph      = 10;
int yGraph      = 300;
int xObj        = 700;
int yObj        = 450;
int xParam      = 180;
int yParam      = 15;
int xRC         = 625;
int yRC         = 370;
int xMot        = 480;
int yMot        = 30;
int BatVolt     = 0;
int FWV         = 11;
int mismatch    = 0;
int TestFW      = 0;
int revrun      = 0;

int xSens       = xParam + 90;
int ySens       = yParam + 110;


int SpinDirection       = 0;
int ActiveFreewheeling  = 1;
int InputSignal         = 0;
int PWMIn               = 0;
int PWMOut              = 5;
int Timing              = 2;
int I2CAdress           = 41;

int CalibCL             = 0;
int CLmode              = 0;
float P8                = 60;
float I8                = 60;
int MaxRpm              = 0;
int MinRpm              = 0;


/*=====================================================================================
  object init
=====================================================================================*/

boolean rpmGraph =true,pwmGraph=true,voltGraph=true,currGraph=false,tempGraph=false;


cDataArray PWM      = new cDataArray(100);
cDataArray RPM      = new cDataArray(100);
cDataArray VOLTAGE  = new cDataArray(100);
cDataArray CURRENT  = new cDataArray(100);
cDataArray TEMP     = new cDataArray(100);


Slider rcStickThrottleSlider;


Button CalibCLB;
Button CLmodeB;
Numberbox P8N;
Numberbox I8N;
Numberbox MaxRpmN;
Numberbox MinRpmN;


Slider PWMSlider;
Slider RPMSlider;
Slider VOLTSlider;
Slider CURRSlider;
Slider TENMPSlider;


Slider DB1Slider;
Slider DB2Slider;


Button buttonREAD;
Button buttonWRITE;
Button buttonSTART;
Button buttonSTOP;

Numberbox mPoleC;


Numberbox MinCommand;
Numberbox MaxCommand;
Numberbox StartCommand;
Numberbox SoftStart;
Numberbox BrakeForce;

Button buttonCW;
Button buttonCCW;

Button buttonAFWON;
Button buttonAFWOFF;

Button buttonPWM;
Button buttonI2C;

Button buttonPWM_NORMAL;
Button buttonPWM_1KHZ;
Button buttonPWM_ONE_SHOT;

Button buttonPWM_6KHZ;
Button buttonPWM_8KHZ;
Button buttonPWM_12KHZ;
Button buttonPWM_16KHZ;
Button buttonPWM_24KHZ;
Button buttonPWM_32KHZ;
Button buttonPWM_48KHZ;
Button buttonPWM_64KHZ;
Button buttonPWM_96KHZ;
Button buttonPWM_128KHZ;
Button buttonPWM_192KHZ;


Button button0DEG;
Button button7DEG;
Button button15DEG;
Button button22DEG;
Button button30DEG;

Button buttonREV;

Numberbox SLOWSlider;
Numberbox SLOWVSlider;
Numberbox CUTVSlider;
Numberbox I2CSlider;




int yellow_ = color(200, 200, 20);
int green_ = color(30, 120, 30);
int red_ = color(120, 40, 27);
int blue_ = color(30, 30, 255);
int greay_ = color(50, 50, 50);

boolean graphEnable = false;
boolean readEnable = false;
boolean writeEnable = false;

int pwmF,debug1,debug2,debug3,debug4 = 0;
float r;
float voltF,currentF,rpmF,rpmX,tempF = 0;
int init_com = 0;
int graph_on = 0;
int commListMax = 0;

float time1;
float time2;

float rcThrottle = 1000;

PImage bgimg;
PImage Graph_bgimg;
PImage logo;
PImage setbg;
PImage flydulogo;

/*=====================================================================================
  setup
=====================================================================================*/

public void setup() {
  size(windowsX,windowsY);
  bgimg = loadImage("../style/bg.jpg");
  Graph_bgimg = loadImage("../style/graphBG.jpg");
  logo = loadImage("../style/uESC_logo_small.jpg");
  setbg = loadImage("../style/setBG.png");
  flydulogo = loadImage("../style/flydulogo.png");
  frameRate(20); 
  controlP5 = new ControlP5(this); // initialize the GUI controls
  controlP5.setControlFont(createFont("verdana bold",10));
  background(0);
 
  g_graph  = new cGraph(120,10, 480, 200);
  // make a listbox and populate it with the available comm ports
  commListbox = controlP5.addListBox("portComList",5,65,105,185); //addListBox(name,x,y,width,height)
  commListbox.captionLabel().toUpperCase(true);
  commListbox.captionLabel().set("COM Ports");
  commListbox.setColorBackground(red_);
  for(int i=0;i<Serial.list().length;i++) {
    String pn = shortifyPortName(Serial.list()[i], 13);
    if(pn.length() > 0) commListbox.addItem(pn, i); // addItem(name,value)
    commListMax = i;
  }
  commListbox.addItem("Close Comm",++commListMax); // addItem(name,value)

  // text label for which comm port selected
  txtlblWhichcom = controlP5.addTextlabel("txtlblWhichcom","No Port Selected",10,42); // textlabel(name,text,x,y)
  
  buttonREAD = controlP5.addButton("READ_SETTINGS",1,xParam-55,yParam+220,104,19); // buton(name,value,x,y,width,height)
  buttonREAD.setColorBackground(red_);
  
  buttonWRITE = controlP5.addButton("WRITE_SETTINGS",1,xParam+497,yParam+220,108,19); // buton(name,value,x,y,width,height)
  buttonWRITE.setColorBackground(red_);
  
  buttonSTART = controlP5.addButton("START_LIVE_DATA",1,xGraph+110,yGraph-30,118,19); // buton(name,value,x,y,width,height)
  buttonSTART.setColorBackground(red_);
  
  buttonSTOP = controlP5.addButton("STOP",1,xGraph+238,yGraph-30,40,19); // buton(name,value,x,y,width,height)
  buttonSTOP.setColorBackground(red_);

  controlP5.addToggle("TEMP",false,xGraph-7,yGraph,20,15);
  controlP5.addToggle("PWM",true,xGraph-7,yGraph+40,20,15);
  controlP5.addToggle("RPM",true,xGraph-7,yGraph+80,20,15);
  controlP5.addToggle("VOLTAGE",true,xGraph-7,yGraph+120,20,15);
  controlP5.addToggle("CURRENT",false,xGraph-7,yGraph+160,20,15);
  

  rcStickThrottleSlider = controlP5.addSlider("Throttle",800,2200,1000,xRC,yRC,10,100);
  rcStickThrottleSlider.setDecimalPrecision(0);

  TENMPSlider  = controlP5.addSlider("     ",0,100,0,xGraph+58,yGraph+10,50,10);TENMPSlider.setDecimalPrecision(1);
  PWMSlider  = controlP5.addSlider(" ",0,2100,0,xGraph+58,yGraph+50,50,10);PWMSlider.setDecimalPrecision(0);
  RPMSlider  = controlP5.addSlider("  ",0,290000,0,xGraph+58,yGraph+90,50,10);RPMSlider.setDecimalPrecision(0);
  VOLTSlider  = controlP5.addSlider("   ",0,300,0,xGraph+58,yGraph+130,50,10);VOLTSlider.setDecimalPrecision(1);
  CURRSlider  = controlP5.addSlider("    ",0,100,0,xGraph+58,yGraph+170,50,10);CURRSlider.setDecimalPrecision(1);
  
  DB1Slider = controlP5.addSlider("debug1",-32767,+32767,0,xGraph+670,yGraph+140,50,10);DB1Slider.setDecimalPrecision(0);
  DB2Slider = controlP5.addSlider("debug2",-32767,+32767,0,xGraph+670,yGraph+160,50,10);DB2Slider.setDecimalPrecision(0);
  
  
  mPoleC = controlP5.addNumberbox("M. Pole count",0,xGraph-7,yGraph-60,40,14);
  mPoleC.setDirection(Controller.HORIZONTAL);
  mPoleC.setDecimalPrecision(0);
  mPoleC.setMin(2);
  mPoleC.setMax(42);
  mPoleC.setColorBackground(green_);
  mPoleC.setValue(14);
  
  
  MinCommand = controlP5.addNumberbox("Min Command",0,xParam+100,yParam-5,40,14);
  MinCommand.setDirection(Controller.HORIZONTAL);
  MinCommand.setDecimalPrecision(0);
  MinCommand.setMin(1000);
  MinCommand.setMax(2000);
  MinCommand.setColorBackground(green_);
  MinCommand.setValue(1000);
  
  
  I2CSlider = controlP5.addNumberbox("I2C ADR",0,xParam+560,yParam+250,40,14);
  I2CSlider.setDirection(Controller.HORIZONTAL);
  I2CSlider.setDecimalPrecision(0);
  I2CSlider.setMin(0);
  I2CSlider.setMax(127);
  I2CSlider.setColorBackground(green_);
  I2CSlider.setValue(41);


  MaxCommand = controlP5.addNumberbox("Max Command",0,xParam+200,yParam-5,40,14);
  MaxCommand.setDirection(Controller.HORIZONTAL);
  MaxCommand.setDecimalPrecision(0);
  MaxCommand.setMin(1400);
  MaxCommand.setMax(2000);
  MaxCommand.setColorBackground(green_);
  MaxCommand.setValue(2000);
  
  StartCommand = controlP5.addNumberbox("Start at",0,xParam+300,yParam-5,40,14);
  StartCommand.setDirection(Controller.HORIZONTAL);
  StartCommand.setDecimalPrecision(0);
  StartCommand.setMin(1050);
  StartCommand.setMax(1500);
  StartCommand.setColorBackground(green_);
  StartCommand.setValue(1100);
  
  SoftStart = controlP5.addNumberbox("soft Start",0,xParam+400,yParam-5,40,14);
  SoftStart.setDirection(Controller.HORIZONTAL);
  SoftStart.setDecimalPrecision(0);
  SoftStart.setMin(0);
  SoftStart.setMax(255);
  SoftStart.setColorBackground(green_);
  SoftStart.setValue(0);

  BrakeForce = controlP5.addNumberbox("brake force",0,xParam+500,yParam-5,40,14);
  BrakeForce.setDirection(Controller.HORIZONTAL);
  BrakeForce.setDecimalPrecision(0);
  BrakeForce.setMin(0);
  BrakeForce.setMax(1000);
  BrakeForce.setColorBackground(green_);
  BrakeForce.setValue(0);
  
  
  buttonCW = controlP5.addButton("CW",0,xParam+100,yParam+41,40,14); // buton(name,value,x,y,width,height)
  buttonCW.setColorBackground(green_);
  
  buttonCCW = controlP5.addButton("CCW",0,xParam+200,yParam+41,40,14); // buton(name,value,x,y,width,height)
  buttonCCW.setColorBackground(red_);
  
  buttonAFWON = controlP5.addButton("ON",0,xParam+450,yParam+41,40,14); // buton(name,value,x,y,width,height)
  buttonAFWON.setColorBackground(green_);
  
  buttonAFWOFF = controlP5.addButton("OFF",0,xParam+525,yParam+41,40,14); // buton(name,value,x,y,width,height)
  buttonAFWOFF.setColorBackground(red_);
  
  buttonPWM = controlP5.addButton("RX_PWM",0,xParam+100,yParam+76,60,14); // buton(name,value,x,y,width,height)
  buttonPWM.setColorBackground(green_);
 
  buttonI2C = controlP5.addButton("I2C",0,xParam+200,yParam+76,40,14); // buton(name,value,x,y,width,height)
  buttonI2C.setColorBackground(greay_);
  
  buttonPWM_NORMAL = controlP5.addButton("F50_500HZ",0,xParam+405,yParam+76,70,14); // buton(name,value,x,y,width,height)
  buttonPWM_NORMAL.setColorBackground(green_);
 
  buttonPWM_1KHZ = controlP5.addButton("F1KHZ",0,xParam+477,yParam+76,45,14); // buton(name,value,x,y,width,height)
  buttonPWM_1KHZ.setColorBackground(red_);
  
  buttonPWM_ONE_SHOT = controlP5.addButton("ONE_SHOT125",0,xParam+524,yParam+76,86,14); // buton(name,value,x,y,width,height)
  buttonPWM_ONE_SHOT.setColorBackground(red_);
  
  buttonPWM_6KHZ = controlP5.addButton("F6KHZ",0,xParam+100,yParam+111,41,14); // buton(name,value,x,y,width,height)
  buttonPWM_6KHZ.setColorBackground(red_);
  buttonPWM_8KHZ = controlP5.addButton("F8KHZ",0,xParam+148,yParam+111,41,14); // buton(name,value,x,y,width,height)
  buttonPWM_8KHZ.setColorBackground(red_);
  buttonPWM_12KHZ = controlP5.addButton("F12KHZ",0,xParam+196,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_12KHZ.setColorBackground(red_);
  buttonPWM_16KHZ = controlP5.addButton("F16KHZ",0,xParam+250,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_16KHZ.setColorBackground(red_);
  buttonPWM_24KHZ = controlP5.addButton("F24KHZ",0,xParam+304,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_24KHZ.setColorBackground(red_);
  buttonPWM_32KHZ = controlP5.addButton("F32KHZ",0,xParam+358,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_32KHZ.setColorBackground(green_);
  buttonPWM_48KHZ = controlP5.addButton("F48KHZ",0,xParam+412,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_48KHZ.setColorBackground(red_);
  buttonPWM_64KHZ = controlP5.addButton("F64KHZ",0,xParam+466,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_64KHZ.setColorBackground(red_);
  buttonPWM_96KHZ = controlP5.addButton("F96KHZ",0,xParam+520,yParam+111,47,14); // buton(name,value,x,y,width,height)
  buttonPWM_96KHZ.setColorBackground(red_);
  
  button0DEG = controlP5.addButton("T0_DEG",0,xParam+100,yParam+146,56,14); // buton(name,value,x,y,width,height)
  button0DEG.setColorBackground(red_);
  
  button7DEG = controlP5.addButton("T7_DEG",0,xParam+200,yParam+146,56,14); // buton(name,value,x,y,width,height)
  button7DEG.setColorBackground(red_);
  
  button15DEG = controlP5.addButton("T15_DEG",0,xParam+300,yParam+146,56,14); // buton(name,value,x,y,width,height)
  button15DEG.setColorBackground(green_);
  
  button22DEG = controlP5.addButton("T22_DEG",0,xParam+400,yParam+146,56,14); // buton(name,value,x,y,width,height)
  button22DEG.setColorBackground(red_);
  
  button30DEG = controlP5.addButton("T30_DEG",0,xParam+500,yParam+146,56,14); // buton(name,value,x,y,width,height)
  button30DEG.setColorBackground(red_);
  
  
  buttonREV = controlP5.addButton("REVERSIBLE",1,xParam+517,yParam+360,80,19); // buton(name,value,x,y,width,height)
  buttonREV.setColorBackground(red_);
  
  
  SLOWSlider = controlP5.addNumberbox("Slow TO %",0,xParam+100,yParam+175,50,14);
  SLOWSlider.setDirection(Controller.HORIZONTAL);
  SLOWSlider.setDecimalPrecision(0);
  SLOWSlider.setMin(0);
  SLOWSlider.setMax(100);
  SLOWSlider.setColorBackground(green_);
  SLOWSlider.setValue(70);
  
  SLOWVSlider = controlP5.addNumberbox("Slow At voltage",0,xParam+250,yParam+175,50,14);
  SLOWVSlider.setDirection(Controller.HORIZONTAL);
  SLOWVSlider.setDecimalPrecision(1);
  SLOWVSlider.setMultiplier(0.1f);
  SLOWVSlider.setMin(0);
  SLOWVSlider.setMax(35);
  SLOWVSlider.setColorBackground(green_);
  SLOWVSlider.setValue(0);
  
  CUTVSlider = controlP5.addNumberbox("Cutoff voltage",0,xParam+400,yParam+175,50,14);
  CUTVSlider.setDirection(Controller.HORIZONTAL);
  CUTVSlider.setDecimalPrecision(1);
  CUTVSlider.setMin(0);
  CUTVSlider.setMultiplier(0.1f);
  CUTVSlider.setMax(35);
  CUTVSlider.setColorBackground(green_);
  CUTVSlider.setValue(0);
  
  CalibCLB = controlP5.addButton("CL_CALIB",0,119+300,500,63,14); // buton(name,value,x,y,width,height)
  CalibCLB.setColorBackground(red_);
 
  CLmodeB = controlP5.addButton("CL_MODE",0,119+200,500,63,14); // buton(name,value,x,y,width,height)
  CLmodeB.setColorBackground(red_); 
  
  P8N = controlP5.addNumberbox("CL_P",0,119+390,500,35,14);
  P8N.setDirection(Controller.HORIZONTAL);
  P8N.setDecimalPrecision(1);
  P8N.setMin(0);
  P8N.setMax(30);
  P8N.setColorBackground(green_);
  P8N.setMultiplier(0.1f);
  P8N.setValue(5);
  
  I8N = controlP5.addNumberbox("CL_I",0,119+444,500,35,14);
  I8N.setDirection(Controller.HORIZONTAL);
  I8N.setDecimalPrecision(1);
  I8N.setMin(0);
  I8N.setMax(30);
  I8N.setColorBackground(green_);
  I8N.setMultiplier(0.1f);
  I8N.setValue(5);
  /*
  MaxRpmN = controlP5.addNumberbox("MAX_RPM",0,119+325,500,59,14);
  MaxRpmN.setDirection(Controller.HORIZONTAL);
  MaxRpmN.setDecimalPrecision(0);
  MaxRpmN.setMin(0);
  MaxRpmN.setMax(66000);
  MaxRpmN.setColorBackground(green_);
  MaxRpmN.setValue(0);
  
  MinRpmN = controlP5.addNumberbox("MIN_RPM",0,119+420,500,59,14);
  MinRpmN.setDirection(Controller.HORIZONTAL);
  MinRpmN.setDecimalPrecision(0);
  MinRpmN.setMin(0);
  MinRpmN.setMax(66000);
  MinRpmN.setColorBackground(green_);
  MinRpmN.setValue(0);
  */

  
}

/*=====================================================================================
  draw "loop"
=====================================================================================*/

public void draw() {
  int i;
  float val;
  float inter;
  float a;
  float b;
  float sina;
  float sinb;
  float cosa;
  float cosb;

  background(53, 78, 79);
  
  image(bgimg, 0, 280);
  image(logo, 5, 5);
  image(flydulogo, xGraph+616, yGraph-5);
  textFont(createFont("verdana bold",11), 11);
  text("v1.1 Release", 700, 486);
  
  
  
  time1=millis();
  if (init_com==1) {
    while (g_serial.available() >0)
      processSerialData();
    if ((time1-time2)>80 && graph_on==1) {
      g_serial.write('A');
      time2=time1;
    }
  }
  controlP5.draw();
  

  PWMSlider.setValue(pwmF);
  RPMSlider.setValue(rpmF);
  VOLTSlider.setValue((voltF/10));
  CURRSlider.setValue((currentF/10));
  TENMPSlider.setValue(tempF);

  rcStickThrottleSlider.setValue(rcThrottle);
  
  DB1Slider.setValue(debug1);
  DB2Slider.setValue(debug2);


  stroke(255); 

  float size = 30.0f;

  strokeWeight(1);
  fill(255, 255, 255);
  g_graph.drawGraphBox();
  image(Graph_bgimg, 118, 290);
  
  strokeWeight(2);
  stroke(255, 0, 0);
  stroke(30, 30, 255);
  if (pwmGraph) g_graph.drawLine(PWM, -20, +2100);
  stroke(255, 0, 255);
  if (rpmGraph)g_graph.drawLine(RPM, -20, +20000);
  stroke(0, 255, 255);
  if (voltGraph)g_graph.drawLine(VOLTAGE, -20, +300);
  stroke(200, 200, 30);
  if (currGraph)g_graph.drawLine(CURRENT, -20, +500);
  stroke(150,150,150);
  if (tempGraph)g_graph.drawLine(TEMP, -20, +1000);

  strokeWeight(4);
  stroke(150,150,150);   line(xGraph+25, yGraph+10, xGraph+50, yGraph+10);
  stroke(30, 30, 255);   line(xGraph+25, yGraph+50, xGraph+50, yGraph+50);
  stroke(255, 0, 255);   line(xGraph+25, yGraph+90, xGraph+50, yGraph+90);
  stroke(0, 255, 255);   line(xGraph+25, yGraph+130, xGraph+50, yGraph+130);
  stroke(200, 200, 30);   line(xGraph+25, yGraph+170, xGraph+50, yGraph+170);
  fill(0, 0, 0);

  //strokeWeight(2);
  //stroke(0, 0, 0);
  //rectMode(CORNERS);
  //rect(xParam-60,yParam-8, xParam+610, yParam+245);
  image(setbg, xParam-64, yParam-8);
  

  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("Basic Setup:", 125, 30);
  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("Spin Direction:", 125, 67);
  text("Active Freewheeling:", 460, 67);
  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("Input Signal:", 125, 102);
  text("PWM input Speed:", 460, 102);
  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("PWM Frequency:", 125, 137);
  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("Timing:", 125, 172);
  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("LiPo Protection:", 125, 210);
  
  
  strokeWeight(1);
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 12);
  text("P", 119+379,511);
  text("I", 119+433,511);
  textFont(createFont("verdana bold",11), 12);
  text("Closed Loop:", 119,511);
  //text("Max", 119+295,511);
  //text("Min", 119+395,511);
  
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 10);
  text("Arm signal is 1500", xParam+507,yParam+390);
  fill(255, 255, 255);
  textFont(createFont("verdana bold",10), 10); 
  text("+-(Start At -1000)/2", xParam+499,yParam+400); 

  if(mismatch == 1){
      fill(200, 0, 0);
      textFont(createFont("verdana bold",15), 12);
      text("Firmware mismatch GUI ver "+FWV+" ESC ver "+TestFW, 220, 400);   
      fill(255, 255, 255);
  }
}

public void PWM(boolean theFlag) {pwmGraph = theFlag;}
public void RPM(boolean theFlag) {rpmGraph = theFlag;}
public void VOLTAGE(boolean theFlag) {voltGraph = theFlag;}
public void CURRENT(boolean theFlag) {currGraph = theFlag;}
public void TEMP(boolean theFlag) {tempGraph = theFlag;}

public void CL_MODE(int theValue) {
  if(CLmode == 0){
    CLmode = 1;
    CLmodeB.setColorBackground(green_);
  }else{
    CLmode = 0;
    CLmodeB.setColorBackground(red_);    
  }
}
public void CL_CALIB(int theValue) {
  if(CalibCL == 0){
    CalibCL = 1;
    CalibCLB.setColorBackground(green_);
  }else{
    CalibCL = 0;
    CalibCLB.setColorBackground(red_);    
  }
}

public void CW(int theValue) {
  SpinDirection = 0;
  buttonCW.setColorBackground(green_);
  buttonCCW.setColorBackground(red_);
}
public void CCW(int theValue) {
  SpinDirection = 1;
  buttonCW.setColorBackground(red_);
  buttonCCW.setColorBackground(green_);
}

public void ON(int theValue) {
  ActiveFreewheeling = 1;
  buttonAFWON.setColorBackground(green_);
  buttonAFWOFF.setColorBackground(red_);
}
public void OFF(int theValue) {
  ActiveFreewheeling = 0;
  buttonAFWON.setColorBackground(red_);
  buttonAFWOFF.setColorBackground(green_);
}

public void RX_PWM(int theValue) {
  InputSignal = 0;
  buttonPWM.setColorBackground(green_);
  buttonI2C.setColorBackground(greay_);
}
public void I2C(int theValue) {
  /*
  InputSignal = 1;
  buttonPWM.setColorBackground(red_);
  buttonI2C.setColorBackground(green_);
  */
}

public void F50_500HZ(int theValue) {
  PWMIn  = 0;
  buttonPWM_NORMAL.setColorBackground(green_);
  buttonPWM_ONE_SHOT.setColorBackground(red_);
  buttonPWM_1KHZ.setColorBackground(red_);
}
public void F1KHZ(int theValue) {
  PWMIn  = 1;
  buttonPWM_NORMAL.setColorBackground(red_);
  buttonPWM_ONE_SHOT.setColorBackground(red_);
  buttonPWM_1KHZ.setColorBackground(green_);
}
public void ONE_SHOT125(int theValue) {
  PWMIn  = 2;
  buttonPWM_ONE_SHOT.setColorBackground(green_);
  buttonPWM_NORMAL.setColorBackground(red_);
  buttonPWM_1KHZ.setColorBackground(red_);
}

public void allPWMred(){
  buttonPWM_6KHZ.setColorBackground(red_);
  buttonPWM_8KHZ.setColorBackground(red_);
  buttonPWM_12KHZ.setColorBackground(red_);
  buttonPWM_16KHZ.setColorBackground(red_);
  buttonPWM_24KHZ.setColorBackground(red_);
  buttonPWM_32KHZ.setColorBackground(red_);
  buttonPWM_48KHZ.setColorBackground(red_);
  buttonPWM_64KHZ.setColorBackground(red_);
  buttonPWM_96KHZ.setColorBackground(red_);
}


public void F6KHZ(int theValue) {
  PWMOut = 0;
  allPWMred();
  buttonPWM_6KHZ.setColorBackground(green_);
}
public void F8KHZ(int theValue) {
  PWMOut = 1;
  allPWMred();
  buttonPWM_8KHZ.setColorBackground(green_);
}
public void F12KHZ(int theValue) {
  PWMOut = 2;
  allPWMred();
  buttonPWM_12KHZ.setColorBackground(green_);
}
public void F16KHZ(int theValue) {
  PWMOut = 3;
  allPWMred();
  buttonPWM_16KHZ.setColorBackground(green_);
}
public void F24KHZ(int theValue) {
  PWMOut = 4;
  allPWMred();
  buttonPWM_24KHZ.setColorBackground(green_);
}
public void F32KHZ(int theValue) {
  PWMOut = 5;
  allPWMred();
  buttonPWM_32KHZ.setColorBackground(green_);
}
public void F48KHZ(int theValue) {
  PWMOut = 6;
  allPWMred();
  buttonPWM_48KHZ.setColorBackground(green_);
}
public void F64KHZ(int theValue) {
  PWMOut = 7;
  allPWMred();
  buttonPWM_64KHZ.setColorBackground(green_);
}
public void F96KHZ(int theValue) {
  PWMOut = 8;
  allPWMred();
  buttonPWM_96KHZ.setColorBackground(green_);
}


public void allTIMINGred(){
  button0DEG.setColorBackground(red_);
  button7DEG.setColorBackground(red_);
  button15DEG.setColorBackground(red_);
  button22DEG.setColorBackground(red_);
  button30DEG.setColorBackground(red_);
}
public void T0_DEG(int theValue) {
  Timing = 0;
  allTIMINGred();
  button0DEG.setColorBackground(green_);
}
public void T7_DEG(int theValue) {
  Timing = 1;
  allTIMINGred();
  button7DEG.setColorBackground(green_);
}
public void T15_DEG(int theValue) {
  Timing = 2;
  allTIMINGred();
  button15DEG.setColorBackground(green_);
}
public void T22_DEG(int theValue) {
  Timing = 3;
  allTIMINGred();
  button22DEG.setColorBackground(green_);
}
public void T30_DEG(int theValue) {
  Timing = 4;
  allTIMINGred();
  button30DEG.setColorBackground(green_);
}

public void REVERSIBLE(int theValue) {
  if(revrun == 0){
    buttonREV.setColorBackground(green_);
    revrun = 1;
  }else{
    buttonREV.setColorBackground(red_);
    revrun = 0;
  }
}


// print the name of the control being triggered (for debugging) and see if it was a Listbox event
public void controlEvent(ControlEvent theEvent) {
  // ListBox is if type ControlGroup, you need to check the Event with if (theEvent.isGroup())to avoid an error message from controlP5
  if (theEvent.isGroup()) {
    // an event from a group
    if (theEvent.name()=="portComList") {
      InitSerial(theEvent.group().value()); // initialize the serial port selected
      println("got portComList"+"   value = "+theEvent.group().value()); // for debugging
      //READ_SETTINGS();
    }
  }
  else {
    //println(theEvent.controller().name()); // for debugging
  }
}

public void START_LIVE_DATA(int theValue) {
  if(graphEnable == false) {return;}
  graph_on=1;
  buttonREAD.setColorBackground(red_);
  buttonWRITE.setColorBackground(red_);
}

public void STOP(int theValue) {
  graph_on=0;
  buttonREAD.setColorBackground(green_);
  buttonWRITE.setColorBackground(green_);
}



public void READ_FW_INFO() {
  int TimeOut = 0;
  float CutVolt  = 0.0f;
  float SlowVolt = 0.0f;
  if(graph_on == 1) {return;}
  g_serial.write('I');
  byte[] inBuf = new byte[100];
  
  TimeOut=millis();
  while(g_serial.read() != 'I'){if(millis()-TimeOut > 1000) return;}
    TimeOut=millis();
    while (g_serial.available() <3) {if(millis()-TimeOut > 1000) return;}
    g_serial.readBytes(inBuf);
    TestFW  = inBuf[1];
    if(TestFW != FWV){
        mismatch = 1;
        txtlblWhichcom.setValue("Comm Closed");
        init_com=0;
        buttonSTART.setColorBackground(red_);buttonSTOP.setColorBackground(red_);commListbox.setColorBackground(red_);
        buttonREAD.setColorBackground(red_);
        buttonWRITE.setColorBackground(red_);
        graphEnable = false;
        init_com=0;
        g_serial.stop();
    }else{
      READ_CONFIG(); 
    }
}
    



public void READ_SETTINGS(int theValue) {
  READ_CONFIG();
}

public void READ_CONFIG(){
  int TimeOut = 0;
  float CutVolt  = 0.0f;
  float SlowVolt = 0.0f;
  if(graph_on == 1) {return;}
  
  int[] inBuf = new int[100];
  int ByteCount = 0;
  
  g_serial.write('B');
  
  TimeOut=millis();
  while(g_serial.read() != 'B'){if(millis()-TimeOut > 1000) return;}
    ByteCount = 0;
    TimeOut=millis();
    while (ByteCount < 30){
      if(millis()-TimeOut > 1000) return;
      if(g_serial.available() > 0){
        inBuf[ByteCount] = g_serial.read();
        ByteCount++;
      }
    }
    allPWMred();
    allTIMINGred();
    MinCommand.setValue((inBuf[0]<<8) + (inBuf[1]&0xff));
    MaxCommand.setValue((inBuf[2]<<8) + (inBuf[3]&0xff));
    StartCommand.setValue((inBuf[4]<<8) + (inBuf[5]&0xff));
    SoftStart.setValue((inBuf[6]<<8) + (inBuf[7]&0xff));
    BrakeForce.setValue((inBuf[8]<<8) + (inBuf[9]&0xff));
    SpinDirection       = inBuf[10];
    ActiveFreewheeling  = inBuf[11];
    InputSignal         = inBuf[12];
    PWMIn               = inBuf[13];
    PWMOut              = inBuf[14];
    Timing              = inBuf[15]; 
    SLOWSlider.setValue(inBuf[16]);
    SlowVolt            = (inBuf[17]<<8) + (inBuf[18]&0xff);
    CutVolt             = (inBuf[19]<<8) + (inBuf[20]&0xff);
    mPoleC.setValue(inBuf[21]);
    I2CAdress           = inBuf[22];
    
    CalibCL             = inBuf[23];
    CLmode              = inBuf[24];
    
    P8                  = (inBuf[25]<<8) + (inBuf[26]&0xff);
    I8                  = (inBuf[27]<<8) + (inBuf[28]&0xff);
    
    //MaxRpm              = (inBuf[25]<<8) + (inBuf[26]&0xff);
    //MinRpm              = (inBuf[27]<<8) + (inBuf[28]&0xff);
    
    revrun              = inBuf[29];
    
    if(revrun == 1){
      buttonREV.setColorBackground(green_);
    }else{
      buttonREV.setColorBackground(red_);
    }
    
    if(CalibCL == 0){
      CalibCLB.setColorBackground(red_);
    }else{
      CalibCLB.setColorBackground(green_);
    }
    
    if(CLmode == 0){
      CLmodeB.setColorBackground(red_);
    }else{
      CLmodeB.setColorBackground(green_);
    }
    P8N.setValue(P8/10);
    I8N.setValue(I8/10);
   // MaxRpmN.setValue(MaxRpm);
    //MinRpmN.setValue(MinRpm);
    
    
    SLOWVSlider.setValue(SlowVolt/10);
    CUTVSlider.setValue(CutVolt/10);
    I2CSlider.setValue(I2CAdress);
    
    if(SpinDirection == 0){
      buttonCW.setColorBackground(green_);
      buttonCCW.setColorBackground(red_); 
    }else{
      buttonCW.setColorBackground(red_);
      buttonCCW.setColorBackground(green_);       
    }
    
    if(ActiveFreewheeling == 1){
      buttonAFWON.setColorBackground(green_);
      buttonAFWOFF.setColorBackground(red_);
    }else{
      buttonAFWON.setColorBackground(red_);
      buttonAFWOFF.setColorBackground(green_);      
    } 
    
    if(InputSignal == 0){
      buttonPWM.setColorBackground(green_);
     // buttonI2C.setColorBackground(red_);
    }else{
      buttonPWM.setColorBackground(red_);
      //buttonI2C.setColorBackground(green_);  
    }  
    
    if(PWMIn == 0){
      buttonPWM_NORMAL.setColorBackground(green_);
      buttonPWM_1KHZ.setColorBackground(red_);
      buttonPWM_ONE_SHOT.setColorBackground(red_); 
    }else if(PWMIn == 1){
      buttonPWM_NORMAL.setColorBackground(red_);
      buttonPWM_1KHZ.setColorBackground(green_);
      buttonPWM_ONE_SHOT.setColorBackground(red_); 
    }else{
      buttonPWM_ONE_SHOT.setColorBackground(green_); 
      buttonPWM_NORMAL.setColorBackground(red_);
      buttonPWM_1KHZ.setColorBackground(red_);
    }
    
    switch(PWMOut){
     case 0:
       buttonPWM_6KHZ.setColorBackground(green_);
     break;
     case 1:
       buttonPWM_8KHZ.setColorBackground(green_);
     break;
     case 2:
       buttonPWM_12KHZ.setColorBackground(green_);
     break;
     case 3:
       buttonPWM_16KHZ.setColorBackground(green_);
     break;
     case 4:
       buttonPWM_24KHZ.setColorBackground(green_);
     break;
     case 5:
       buttonPWM_32KHZ.setColorBackground(green_);
     break;
     case 6:
       buttonPWM_48KHZ.setColorBackground(green_);
     break;
     case 7:
       buttonPWM_64KHZ.setColorBackground(green_);
     break;
     case 8:
       buttonPWM_96KHZ.setColorBackground(green_);
     break;
     case 9:
       buttonPWM_128KHZ.setColorBackground(green_);
     break;
     case 10:
       buttonPWM_192KHZ.setColorBackground(green_);
     break;
    } 
    
    switch(Timing){
     case 0:
       button0DEG.setColorBackground(green_);
     break;
     case 1:
       button7DEG.setColorBackground(green_);
     break;
     case 2:
       button15DEG.setColorBackground(green_);
     break;
     case 3:
       button22DEG.setColorBackground(green_);
     break;
     case 4:
       button30DEG.setColorBackground(green_);
     break;
    } 
}





public void WRITE_SETTINGS(int theValue) {
  if(graph_on == 1) {return;}
  int minCom   = 0;
  int maxCom   = 0;
  int StartCom = 0;
  int SoftS    = 0;
  int BrakeF   = 0;
  int SlowTo   = 0;
  long SlowAt   = 0;
  long CutOff   = 0;
  int MPCount  = 0;
  long P88      = 0;
  long I88      = 0;
  //int MaxR8    = 0;
  //int MinR8    = 0;
  
  P88      = round((P8N.value()*10));
  I88      = round((I8N.value()*10));

  //MaxR8    = round(MaxRpmN.value());
  //MinR8    = round(MinRpmN.value());
  
  I2CAdress = round(I2CSlider.value());
  minCom   = round(MinCommand.value());
  maxCom   = round(MaxCommand.value());
  StartCom = round(StartCommand.value());
  SoftS    = round(SoftStart.value());
  BrakeF   = round(BrakeForce.value());  
  
  SlowTo   = round(SLOWSlider.value());
  SlowAt   = round((SLOWVSlider.value()*10));
  CutOff   = round((CUTVSlider.value()*10));
  MPCount  = round(mPoleC.value());
  
  String s = new String("C"
  +(minCom>>8)+";"+(minCom&0xff)+";"       // Min Command
  +(maxCom>>8)+";"+(maxCom&0xff)+";"       // Max Command
  +(StartCom>>8)+";"+(StartCom&0xff)+";"   // Start Command
  +(SoftS>>8)+";"+(SoftS&0xff)+";"         // Soft Start
  +(BrakeF>>8)+";"+(BrakeF&0xff)+";"       // brake Force
  +(SpinDirection)+";"                     // Spin Direction
  +(ActiveFreewheeling)+";"                // ActiveFreewheeling
  +(InputSignal)+";"                       // Input Type (0 = PWM, 1 = I2C)
  +(PWMIn)+";"                             // Input PWM Speed (50-500Hz or 4kHz)
  +(PWMOut)+";"                            // Output PWM Frequency
  +(Timing)+";"                            // Timing 
  +SlowTo+";"                              // Slow down to % in voltage drops
  +(SlowAt>>8)+";"+(SlowAt&0xff)+";"       // Slow down at volatge
  +(CutOff>>8)+";"+(CutOff&0xff)+";"       // cut off at voltage
  +MPCount+";"                             // motor magnetpole count  
  +I2CAdress+";"                           // I2C Adress
  +CalibCL+";"                             // Closed Loop Calibration
  +CLmode+";"                              // Closed Loop  
  +(P88>>8)+";"+(P88&0xff)+";"             // CL P 
  +(I88>>8)+";"+(I88&0xff)+";"             // CL I   
  //+(MaxR8>>8)+";"+(MaxR8&0xff)+";"         // CL clibration Data Max RPM
  //+(MinR8>>8)+";"+(MinR8&0xff)+";");       // CL clibration Data Min RPM
  +(revrun)+";");                          //reverse Run
  
  g_serial.write(s);
  if(CalibCL == 1){
    CalibCL = 0;
    CalibCLB.setColorBackground(red_);
  }
}
public String shortifyPortName(String portName, int maxlen)  {
  String shortName = portName;
  if(shortName.startsWith("/dev/")) shortName = shortName.substring(5);  
  if(shortName.startsWith("tty.")) shortName = shortName.substring(4); // get rid of leading tty. part of device name
  if(portName.length()>maxlen) shortName = shortName.substring(0,(maxlen-1)/2) + "~" +shortName.substring(shortName.length()-(maxlen-(maxlen-1)/2));
  if(shortName.startsWith("cu.")) shortName = "";// only collect the corresponding tty. devices
  return shortName;
}

// initialize the serial port selected in the listBox
public void InitSerial(float portValue) {
  if (portValue < commListMax) {
    String portPos = Serial.list()[PApplet.parseInt(portValue)];
    txtlblWhichcom.setValue("COM = " + shortifyPortName(portPos, 8));
    g_serial = new Serial(this, portPos, 115200);
    init_com=1;
    buttonSTART.setColorBackground(green_);buttonSTOP.setColorBackground(green_);
    if(graph_on == 0){
      buttonREAD.setColorBackground(green_);
      buttonWRITE.setColorBackground(green_);
    }
    graphEnable = true;
    g_serial.buffer(256);
    READ_FW_INFO();
  } else {
    txtlblWhichcom.setValue("Comm Closed");
    init_com=0;
    buttonSTART.setColorBackground(red_);buttonSTOP.setColorBackground(red_);commListbox.setColorBackground(red_);
    buttonREAD.setColorBackground(red_);
    buttonWRITE.setColorBackground(red_);
    graphEnable = false;
    init_com=0;
    g_serial.stop();
  }
}


public void processSerialData() {
  int TimeOut = 0;
  int ByteCount = 0;
  int[] inBuf = new int[100];
 // while(g_serial.read() != 'A'){if(millis()-TimeOut > 1000) return;}
  
  if (g_serial.read() == 'A') {
    ByteCount = 0;
    TimeOut=millis();
    while (ByteCount < 15){
      if(millis()-TimeOut > 1000) return;
      if(g_serial.available() > 0){
        inBuf[ByteCount] = g_serial.read();
        ByteCount++;
      }
    }
    pwmF = (inBuf[1]<<8) + (inBuf[0]&0xff);
    rpmX = (inBuf[3]<<8) + (inBuf[2]&0xff);
    voltF = (inBuf[5]<<8) + (inBuf[4]&0xff);
    currentF = (inBuf[7]<<8) + (inBuf[6]&0xff);
    rcThrottle = ((inBuf[9]<<8) + (inBuf[8]&0xff))/2;
    
    debug1  = (inBuf[11]<<8) + (inBuf[10]&0xff);
    debug2  = (inBuf[13]<<8) + (inBuf[12]&0xff);
    tempF   = (inBuf[15]<<8) + (inBuf[14]&0xff);
    
    if(rpmX > 0){
      rpmF = (16000000*60)/((rpmX*6)*(mPoleC.value()/2));
    }else{
      rpmF = 0;
    }
    

    PWM.addVal(pwmF);
    RPM.addVal(rpmF);
    VOLTAGE.addVal(voltF);
    CURRENT.addVal(currentF);
    TEMP.addVal(tempF);
  }
}


//********************************************************
//********************************************************
//********************************************************

class cDataArray {
  float[] m_data;
  int m_maxSize, m_startIndex = 0, m_endIndex = 0, m_curSize;
  
  cDataArray(int maxSize){
    m_maxSize = maxSize;
    m_data = new float[maxSize];
  }
  public void addVal(float val) {
    m_data[m_endIndex] = val;
    m_endIndex = (m_endIndex+1)%m_maxSize;
    if (m_curSize == m_maxSize) {
      m_startIndex = (m_startIndex+1)%m_maxSize;
    } else {
      m_curSize++;
    }
  }
  public float getVal(int index) {return m_data[(m_startIndex+index)%m_maxSize];}
  public int getCurSize(){return m_curSize;}
  public int getMaxSize() {return m_maxSize;}
  public float getMaxVal() {
    float res = 0.0f;
    for(int i=0; i<m_curSize-1; i++) if ((m_data[i] > res) || (i==0)) res = m_data[i];
    return res;
  }
  public float getMinVal() {
    float res = 0.0f;
    for(int i=0; i<m_curSize-1; i++) if ((m_data[i] < res) || (i==0)) res = m_data[i];
    return res;
  }
  public float getRange() {return getMaxVal() - getMinVal();}
}



// This class takes the data and helps graph it
class cGraph {
  float m_gWidth, m_gHeight;
  float m_gLeft, m_gBottom, m_gRight, m_gTop;
  
  cGraph(float x, float y, float w, float h) {
    m_gWidth     = w;
    m_gHeight    = h;
    m_gLeft      = x;
    m_gBottom    = windowsY-20 - y;
    m_gRight     = x + w;
    m_gTop       = windowsY-20 - y - h;
  }
  
  public void drawGraphBox() {
  }
  
  public void drawLine(cDataArray data, float minRange, float maxRange) {
    float graphMultX = m_gWidth/data.getMaxSize();
    float graphMultY = m_gHeight/(maxRange-minRange);
    
    for(int i=0; i<data.getCurSize()-1; ++i) {
      float x0 = i*graphMultX+m_gLeft;
      float y0 = m_gBottom-((data.getVal(i)-minRange)*graphMultY);
      float x1 = (i+1)*graphMultX+m_gLeft;
      float y1 = m_gBottom-((data.getVal(i+1)-minRange)*graphMultY);
      line(x0, y0, x1, y1);
    }
  }
} 

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "UltraESC_Config_1_1" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
